GNU bug report logs - #36550
Small bug fix in recentf.el

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Severity: minor; Reported by: Linus Källberg <linus.kallberg@HIDDEN>; dated Mon, 8 Jul 2019 14:50:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 36550 <at> debbugs.gnu.org:


Received: (at 36550) by debbugs.gnu.org; 14 Jul 2019 05:30:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 14 01:30:47 2019
Received: from localhost ([127.0.0.1]:43725 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hmX5y-0003jh-S0
	for submit <at> debbugs.gnu.org; Sun, 14 Jul 2019 01:30:47 -0400
Received: from eggs.gnu.org ([209.51.188.92]:34165)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hmX5x-0003jU-0q
 for 36550 <at> debbugs.gnu.org; Sun, 14 Jul 2019 01:30:45 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:47750)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hmX5r-00032K-72; Sun, 14 Jul 2019 01:30:39 -0400
Received: from [176.228.60.248] (port=4559 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hmX5q-0001pV-E0; Sun, 14 Jul 2019 01:30:39 -0400
Date: Sun, 14 Jul 2019 08:30:22 +0300
Message-Id: <83ims5yyhd.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Linus =?windows-1252?Q?K=E4llberg?= <linus.kallberg@HIDDEN>
In-reply-to: <AM0PR09MB28677C3C45180F93BF5F297B87CD0@HIDDEN>
 (message from Linus =?windows-1252?Q?K=E4llberg?= on Sat, 13 Jul 2019
 19:49:07 +0000)
Subject: Re: bug#36550: mouse-face overlay calculation error
References: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
 <87v9wc2t8p.fsf@HIDDEN>
 <AM0PR09MB2867529A5BCE4551365F142C87F60@HIDDEN>
 <m3bly3xsto.fsf@HIDDEN>
 <AM0PR09MB2867803F96B1A7F4A5B4C81687F30@HIDDEN>
 <m3v9w6rd0s.fsf_-_@HIDDEN> <831ryu31fc.fsf@HIDDEN>
 <m336jaqdw2.fsf@HIDDEN> <834l3q132a.fsf@HIDDEN> <m3d0ieoxfy.fsf@HIDDEN>
 <83zhliyq5p.fsf@HIDDEN> <m34l3qovts.fsf@HIDDEN> <83y312yony.fsf@HIDDEN>
 <m3muhinff7.fsf@HIDDEN> <m3ims6nf9b.fsf@HIDDEN>
 <AM0PR09MB2867DE510C195B176FC680AC87CD0@HIDDEN>
 <83tvbqylwd.fsf@HIDDEN> 
 <AM0PR09MB28677C3C45180F93BF5F297B87CD0@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=windows-1252
Content-Transfer-Encoding: 8bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36550
Cc: 36550 <at> debbugs.gnu.org, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Linus Kšllberg <linus.kallberg@HIDDEN>
> CC: "larsi@HIDDEN" <larsi@HIDDEN>, "36550 <at> debbugs.gnu.org"
> 	<36550 <at> debbugs.gnu.org>
> Date: Sat, 13 Jul 2019 19:49:07 +0000
> 
> > But that's not what mouse-face means and does.  It highlights
> > mouse-sensitive text, and thus it should NOT include a newline,
> > because a newline does not have a glyph in the buffer text.  That's
> > why you see the 1st character on the next line highlighted: it's the
> > next character after the newline, and since the newline is absent, it
> > gets highlighted instead, because when character positions are not
> > monotonous with screen coordinates, we have no alternative but
> > highlight that next character.
> 
> Are you saying that the mouse-face property should not be used on 
> overlays that contain newline characters, period, or simply those that 
> have a newline character as their *last* character?

The latter.

> I understand that a newline character cannot be clicked or highlighted 
> if it has no glyph in the text, but why can't it then simply not be 
> highlighted?

Because the algorithm to find what is the last glyph to be highlighted
is very complicated (since it cannot rely on buffer positions changing
monotonously with screen coordinates) and in this case it yields a
result that looks wrong.  If someone wants to find how to change the
algorithm so that it also covers this niche use case, feel free.

> is it really intended, in the sense that something else would break
> if it was "fixed"?

It depends on the fix.  I cannot tell until I see a proposal for such
a fix.  The existing code relies on some properties of glyphs as they
are laid out for display, and one of those properties is that the
screen line's end position is the position of the first character on
the next line.  That's why you see what you see in this case.

> >> or possibly one character further to the right (as if there was an
> >> imaginary space character inserted there).
> > 
> > Can't do that, because that imaginary character doesn't exist, and
> > therefore we cannot possible access its buffer position.
> 
> But doesn't it already do that? I use an Emacs theme that underlines 
> highlighted text, and when an overlay contains a newline character 
> (anywhere, not necessarily at the end), there is always one extra 
> "imaginary" character underlined after the last character before the 
> line break.

This is something specific to mouse-face, because unlike other faces,
it works with characters on display, not in the buffer.

> In this example, there is one extra underlined character after "foo":
> 
> (progn
>    (load-theme 'wombat t)
>    (let ((point (point)))
>      (insert "foo\nbar")
>      (let ((o (make-overlay point (point))))
>        (overlay-put o 'mouse-face 'highlight))))

Yes, as expected.

> >> In recentf, the newline after the file name is included in each link so
> >> that if point is positioned right after the last character -- which
> >> happens, e.g., if one i-searches for a file extension -- one can simply
> >> press enter to open the file (as said in the commit message).
> > 
> > But pressing Enter doesn't require mouse-face, does it?  It requires
> > an overlay with a suitable keymap property, right?
> 
> Exactly, I guess the button widget simply uses the same overlay for 
> everything.

Yes, I suggested to use a separate overlay for that.

> > If this fixes the issue, it's fine with me.  However, I think we
> > should have a comment there explaining why we add this space
> > character.
> 
> Yes, a comment should be added. However, I would prefer fixing the real 
> problem, which, if not in the display code, might be in the 
> implementation of the button widget.

Fine with me, if someone wants to work on that.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36550; Package emacs. Full text available.

Message received at 36550 <at> debbugs.gnu.org:


Received: (at 36550) by debbugs.gnu.org; 13 Jul 2019 19:49:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 13 15:49:19 2019
Received: from localhost ([127.0.0.1]:43411 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hmO1G-0004wJ-Kh
	for submit <at> debbugs.gnu.org; Sat, 13 Jul 2019 15:49:19 -0400
Received: from mail-oln040092067083.outbound.protection.outlook.com
 ([40.92.67.83]:56385 helo=EUR02-AM5-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <linus.kallberg@HIDDEN>) id 1hmO1C-0004w1-0O
 for 36550 <at> debbugs.gnu.org; Sat, 13 Jul 2019 15:49:15 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=outlook.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=cCAkIj4xSd7sjoNI+PQq1j4c0oZ+p0KNiE7RwlsKKQM=;
 b=qXo+Wmo/BBHYgvfpS09UY9RtD/1HUc9UIlXQDkOvaoylmrcmOvTtGDTwA9ViNZhPsqztHwj02Omk50qc7gjob7+PGKQwi57+IBKpUWHtFfXpeRu4XFv6/T2VVangFHBEpW81IU8C8kXAysVR3xEkc1VMfVoYnaVcoFt1/if8W0x2fyNv7LskHzxIjHta5+ZmXTBg2K4HDCHl6LdrTTUVLoiROGJIy1skydy7mlLswlieFZGdMff8GxR/fG+YRBmFDHaKw+bF4aP8WUxhSPFp8YbansC+R20r2KVKFOPqKe9WBsxhNPKqkVg0DHt9OULgNKhLfEIew3djvjN/IoBxjQ==
Received: from VE1EUR02FT041.eop-EUR02.prod.protection.outlook.com
 (10.152.12.52) by VE1EUR02HT175.eop-EUR02.prod.protection.outlook.com
 (10.152.13.111) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_CBC_SHA384) id 15.20.2052.19; Sat, 13 Jul
 2019 19:49:07 +0000
Received: from AM0PR09MB2867.eurprd09.prod.outlook.com (10.152.12.57) by
 VE1EUR02FT041.mail.protection.outlook.com (10.152.13.33) with Microsoft SMTP
 Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_CBC_SHA384) id
 15.20.2052.19 via Frontend Transport; Sat, 13 Jul 2019 19:49:07 +0000
Received: from AM0PR09MB2867.eurprd09.prod.outlook.com
 ([fe80::bc7b:8964:ba14:f6a2]) by AM0PR09MB2867.eurprd09.prod.outlook.com
 ([fe80::bc7b:8964:ba14:f6a2%3]) with mapi id 15.20.2073.012; Sat, 13 Jul 2019
 19:49:07 +0000
From: =?Windows-1252?Q?Linus_K=E4llberg?= <linus.kallberg@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36550: mouse-face overlay calculation error
Thread-Topic: bug#36550: mouse-face overlay calculation error
Thread-Index: AQHVORJK1h+C6vMxBU6hzne99E+cCabIEqsEgABzzsSAAAOtSIAAB6shgAAHoW6AAAIcgIAABvVjgAAEILGAAAD+AoAACBUAgAADc+yAAEKwAA==
Date: Sat, 13 Jul 2019 19:49:07 +0000
Message-ID: <AM0PR09MB28677C3C45180F93BF5F297B87CD0@HIDDEN>
References: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
 <87v9wc2t8p.fsf@HIDDEN>
 <AM0PR09MB2867529A5BCE4551365F142C87F60@HIDDEN>
 <m3bly3xsto.fsf@HIDDEN>
 <AM0PR09MB2867803F96B1A7F4A5B4C81687F30@HIDDEN>
 <m3v9w6rd0s.fsf_-_@HIDDEN> <831ryu31fc.fsf@HIDDEN>
 <m336jaqdw2.fsf@HIDDEN> <834l3q132a.fsf@HIDDEN> <m3d0ieoxfy.fsf@HIDDEN>
 <83zhliyq5p.fsf@HIDDEN> <m34l3qovts.fsf@HIDDEN> <83y312yony.fsf@HIDDEN>
 <m3muhinff7.fsf@HIDDEN> <m3ims6nf9b.fsf@HIDDEN>
 <AM0PR09MB2867DE510C195B176FC680AC87CD0@HIDDEN>
 <83tvbqylwd.fsf@HIDDEN>
In-Reply-To: <83tvbqylwd.fsf@HIDDEN>
Accept-Language: sv-SE, en-US
Content-Language: en-US
X-MS-Has-Attach: 
X-MS-TNEF-Correlator: 
x-clientproxiedby: HE1P195CA0014.EURP195.PROD.OUTLOOK.COM (2603:10a6:3:fd::24)
 To AM0PR09MB2867.eurprd09.prod.outlook.com
 (2603:10a6:208:134::10)
x-incomingtopheadermarker: OriginalChecksum:13C90370B233140F963F48FC2B8B04E39C4AA25BC998AB6D2E8A275AE0D21459;
 UpperCasedChecksum:AEAF75767ED45B2D375ED2369E87FE620E7C4FA86C3CCA3E601BCB10FC71623F;
 SizeAsReceived:8133; Count:49
x-ms-exchange-messagesentrepresentingtype: 1
x-tmn: [c/zqQWJ4/SaIFfiKFJuKwQIuxnDqlQh0]
x-microsoft-original-message-id: <6fe53262-9db7-d528-561b-3a355085fc84@HIDDEN>
x-ms-publictraffictype: Email
x-incomingheadercount: 49
x-eopattributedmessage: 0
x-microsoft-antispam: BCL:0; PCL:0;
 RULEID:(2390118)(5050001)(7020095)(20181119110)(201702061078)(5061506573)(5061507331)(1603103135)(2017031320274)(2017031322404)(2017031323274)(2017031324274)(1601125500)(1603101475)(1701031045);
 SRVR:VE1EUR02HT175; 
x-ms-traffictypediagnostic: VE1EUR02HT175:
x-microsoft-antispam-message-info: 2luit2QHSjDDtOUPcot9dpHvEn0ZCoRj2BHm97wNyQ/SogDpp3nLy7ZaWo1b1A7UvJvYD7qxbsLfSYEN82U/IcyMhZn4TwCSM61HdMBxB5ZyIhNRtPqpGBCudne9jRYZMBhqoiD2Zf2lx9ydzTcJbRI7BwxzFHH+Wxi0Yn1wb2192Pqoh2SOa5msBZFt+fqM
Content-Type: text/plain; charset="Windows-1252"
Content-ID: <74A1D792E0E63B4EB093EECF694CFE78@HIDDEN>
Content-Transfer-Encoding: quoted-printable
MIME-Version: 1.0
X-OriginatorOrg: outlook.com
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-CrossTenant-Network-Message-Id: 3df12c30-3dd2-4ddc-135b-08d707cb2a93
X-MS-Exchange-CrossTenant-rms-persistedconsumerorg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-CrossTenant-originalarrivaltime: 13 Jul 2019 19:49:07.2940 (UTC)
X-MS-Exchange-CrossTenant-fromentityheader: Internet
X-MS-Exchange-CrossTenant-id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-Transport-CrossTenantHeadersStamped: VE1EUR02HT175
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 36550
Cc: "36550 <at> debbugs.gnu.org" <36550 <at> debbugs.gnu.org>,
 "larsi@HIDDEN" <larsi@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Den 2019-07-13 kl. 17:49, skrev Eli Zaretskii:
>> From: Linus K=E4llberg <linus.kallberg@HIDDEN>
>> CC: "36550 <at> debbugs.gnu.org" <36550 <at> debbugs.gnu.org>
>> Date: Sat, 13 Jul 2019 15:38:05 +0000
>>
>> I might have misunderstood the discussion, but just to clarify my
>> opinion, if the overlay ends with a newline character, the mouse-face
>> should *not* extend to the right edge of the window (and definitely not
>> to the first character on the next line).
>=20
> But that's not what mouse-face means and does.  It highlights
> mouse-sensitive text, and thus it should NOT include a newline,
> because a newline does not have a glyph in the buffer text.  That's
> why you see the 1st character on the next line highlighted: it's the
> next character after the newline, and since the newline is absent, it
> gets highlighted instead, because when character positions are not
> monotonous with screen coordinates, we have no alternative but
> highlight that next character.

Are you saying that the mouse-face property should not be used on=20
overlays that contain newline characters, period, or simply those that=20
have a newline character as their *last* character? I must say, it does=20
seem like a bug that the appearance of characters not even included in=20
the overlay (i.e., the first character on the next line) is changed when=20
hovering the mouse over it.

I understand that a newline character cannot be clicked or highlighted=20
if it has no glyph in the text, but why can't it then simply not be=20
highlighted? Why must the first character on the next line be=20
highlighted instead? No doubt it is difficult to change this behavior=20
due to the complicated logic involved, but is it really intended, in the=20
sense that something else would break if it was "fixed"?

>> or possibly one character further to the right (as if there was an
>> imaginary space character inserted there).
>=20
> Can't do that, because that imaginary character doesn't exist, and
> therefore we cannot possible access its buffer position.

But doesn't it already do that? I use an Emacs theme that underlines=20
highlighted text, and when an overlay contains a newline character=20
(anywhere, not necessarily at the end), there is always one extra=20
"imaginary" character underlined after the last character before the=20
line break.

In this example, there is one extra underlined character after "foo":

(progn
   (load-theme 'wombat t)
   (let ((point (point)))
     (insert "foo\nbar")
     (let ((o (make-overlay point (point))))
       (overlay-put o 'mouse-face 'highlight))))

>> In recentf, the newline after the file name is included in each link so
>> that if point is positioned right after the last character -- which
>> happens, e.g., if one i-searches for a file extension -- one can simply
>> press enter to open the file (as said in the commit message).
>=20
> But pressing Enter doesn't require mouse-face, does it?  It requires
> an overlay with a suitable keymap property, right?

Exactly, I guess the button widget simply uses the same overlay for=20
everything.

>> As I said earlier, one way to fix the issue in recentf is simply to move
>> the newline outside of the link, but put a space character after each
>> file name. This way, the mouse-over highlights look okay, and one can
>> still i-search for a file extension and then simply press enter. Here is
>> a patch that does this:
>=20
> If this fixes the issue, it's fine with me.  However, I think we
> should have a comment there explaining why we add this space
> character.

Yes, a comment should be added. However, I would prefer fixing the real=20
problem, which, if not in the display code, might be in the=20
implementation of the button widget.

Best regards,
Linus K=E4llberg




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36550; Package emacs. Full text available.

Message received at 36550 <at> debbugs.gnu.org:


Received: (at 36550) by debbugs.gnu.org; 13 Jul 2019 15:50:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 13 11:50:17 2019
Received: from localhost ([127.0.0.1]:43206 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hmKHw-00051R-SK
	for submit <at> debbugs.gnu.org; Sat, 13 Jul 2019 11:50:17 -0400
Received: from eggs.gnu.org ([209.51.188.92]:54620)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hmKHu-000519-EG
 for 36550 <at> debbugs.gnu.org; Sat, 13 Jul 2019 11:50:14 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:37125)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hmKHo-0000Kx-Ub; Sat, 13 Jul 2019 11:50:08 -0400
Received: from [176.228.60.248] (port=2360 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hmKHo-0004DZ-Ac; Sat, 13 Jul 2019 11:50:08 -0400
Date: Sat, 13 Jul 2019 18:49:54 +0300
Message-Id: <83tvbqylwd.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Linus =?windows-1252?Q?K=E4llberg?= <linus.kallberg@HIDDEN>
In-reply-to: <AM0PR09MB2867DE510C195B176FC680AC87CD0@HIDDEN>
 (message from Linus =?windows-1252?Q?K=E4llberg?= on Sat, 13 Jul 2019
 15:38:05 +0000)
Subject: Re: bug#36550: mouse-face overlay calculation error
References: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
 <87v9wc2t8p.fsf@HIDDEN>
 <AM0PR09MB2867529A5BCE4551365F142C87F60@HIDDEN>
 <m3bly3xsto.fsf@HIDDEN>
 <AM0PR09MB2867803F96B1A7F4A5B4C81687F30@HIDDEN>
 <m3v9w6rd0s.fsf_-_@HIDDEN> <831ryu31fc.fsf@HIDDEN>
 <m336jaqdw2.fsf@HIDDEN> <834l3q132a.fsf@HIDDEN> <m3d0ieoxfy.fsf@HIDDEN>
 <83zhliyq5p.fsf@HIDDEN> <m34l3qovts.fsf@HIDDEN> <83y312yony.fsf@HIDDEN>
 <m3muhinff7.fsf@HIDDEN> <m3ims6nf9b.fsf@HIDDEN>
 <AM0PR09MB2867DE510C195B176FC680AC87CD0@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=windows-1252
Content-Transfer-Encoding: 8bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36550
Cc: 36550 <at> debbugs.gnu.org, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Linus Kšllberg <linus.kallberg@HIDDEN>
> CC: "36550 <at> debbugs.gnu.org" <36550 <at> debbugs.gnu.org>
> Date: Sat, 13 Jul 2019 15:38:05 +0000
> 
> I might have misunderstood the discussion, but just to clarify my 
> opinion, if the overlay ends with a newline character, the mouse-face 
> should *not* extend to the right edge of the window (and definitely not 
> to the first character on the next line).

But that's not what mouse-face means and does.  It highlights
mouse-sensitive text, and thus it should NOT include a newline,
because a newline does not have a glyph in the buffer text.  That's
why you see the 1st character on the next line highlighted: it's the
next character after the newline, and since the newline is absent, it
gets highlighted instead, because when character positions are not
monotonous with screen coordinates, we have no alternative but
highlight that next character.

> I would expect it to end after the last character before the newline

Can't do that, because the newline is also covered by the face.

> or possibly one character further to the right (as if there was an
> imaginary space character inserted there).

Can't do that, because that imaginary character doesn't exist, and
therefore we cannot possible access its buffer position.

> In recentf, the newline after the file name is included in each link so 
> that if point is positioned right after the last character -- which 
> happens, e.g., if one i-searches for a file extension -- one can simply 
> press enter to open the file (as said in the commit message).

But pressing Enter doesn't require mouse-face, does it?  It requires
an overlay with a suitable keymap property, right?

> However, due to the "bug" in question (if it is indeed a bug), when
> hovering the mouse over a link, the whole line (up to the right edge
> of the window) and the first character on the next line is
> highlighted. I have been using Emacs, and the recentf package, for
> only five years, but I always thought that this looked ugly and
> somewhat "buggy". The other day I was a bit cranky and decided to
> look into it :-)

Indeed, the mouse-face should end before the newline.

> As I said earlier, one way to fix the issue in recentf is simply to move 
> the newline outside of the link, but put a space character after each 
> file name. This way, the mouse-over highlights look okay, and one can 
> still i-search for a file extension and then simply press enter. Here is 
> a patch that does this:

If this fixes the issue, it's fine with me.  However, I think we
should have a comment there explaining why we add this space
character.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36550; Package emacs. Full text available.

Message received at 36550 <at> debbugs.gnu.org:


Received: (at 36550) by debbugs.gnu.org; 13 Jul 2019 15:38:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 13 11:38:15 2019
Received: from localhost ([127.0.0.1]:43202 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hmK6I-0002ZT-E7
	for submit <at> debbugs.gnu.org; Sat, 13 Jul 2019 11:38:14 -0400
Received: from mail-oln040092070024.outbound.protection.outlook.com
 ([40.92.70.24]:23891 helo=EUR03-AM5-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <linus.kallberg@HIDDEN>) id 1hmK6G-0002ZB-7m
 for 36550 <at> debbugs.gnu.org; Sat, 13 Jul 2019 11:38:13 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=outlook.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=xqm6V5Em43cd0FBmfwaH+MSbYz7iGub0BcebYWYMi8U=;
 b=MlazXWGG7mjDXH31oiuQEFaeLsdZ6+URBs3puKqK5tQjPCiddDyEYsfCHwCBZznhQkXdY1aIMzKOFtIhxDBZfHaqHUXJ22dHxZc/jDZ89iIeEuGEwxRS9XIdQTwYXZILF0XM09BJncFCYbDlFV2A4s0fo6eRlAHI/j8IZhZsz+RPsmlgdtNpxbAYrWrSLAKZKPvnyqrvEvehGr+7Ywoknfzc5Sj457rzYddGDEmrS34RORIXqPWwGXiesJzY6eHlhlWN/5xz0rJhQz9DZKsz+FjrFu/qukHMd/bpiAS9P2HvhkPhdOGgFQYpk5tlArs/M0HtPLnfNL2PJ0VKF7Z1oQ==
Received: from DB5EUR03FT029.eop-EUR03.prod.protection.outlook.com
 (10.152.20.51) by DB5EUR03HT090.eop-EUR03.prod.protection.outlook.com
 (10.152.21.136) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_CBC_SHA384) id 15.20.2052.18; Sat, 13 Jul
 2019 15:38:05 +0000
Received: from AM0PR09MB2867.eurprd09.prod.outlook.com (10.152.20.59) by
 DB5EUR03FT029.mail.protection.outlook.com (10.152.20.131) with Microsoft SMTP
 Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_CBC_SHA384) id
 15.20.2052.18 via Frontend Transport; Sat, 13 Jul 2019 15:38:05 +0000
Received: from AM0PR09MB2867.eurprd09.prod.outlook.com
 ([fe80::bc7b:8964:ba14:f6a2]) by AM0PR09MB2867.eurprd09.prod.outlook.com
 ([fe80::bc7b:8964:ba14:f6a2%3]) with mapi id 15.20.2073.012; Sat, 13 Jul 2019
 15:38:05 +0000
From: =?Windows-1252?Q?Linus_K=E4llberg?= <linus.kallberg@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36550: mouse-face overlay calculation error
Thread-Topic: bug#36550: mouse-face overlay calculation error
Thread-Index: AQHVORJK1h+C6vMxBU6hzne99E+cCabIEqsEgABzzsSAAAOtSIAAB6shgAAHoW6AAAIcgIAABvVjgAAEILGAAAD+AoAACBUA
Date: Sat, 13 Jul 2019 15:38:05 +0000
Message-ID: <AM0PR09MB2867DE510C195B176FC680AC87CD0@HIDDEN>
References: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
 <87v9wc2t8p.fsf@HIDDEN>
 <AM0PR09MB2867529A5BCE4551365F142C87F60@HIDDEN>
 <m3bly3xsto.fsf@HIDDEN>
 <AM0PR09MB2867803F96B1A7F4A5B4C81687F30@HIDDEN>
 <m3v9w6rd0s.fsf_-_@HIDDEN> <831ryu31fc.fsf@HIDDEN>
 <m336jaqdw2.fsf@HIDDEN> <834l3q132a.fsf@HIDDEN> <m3d0ieoxfy.fsf@HIDDEN>
 <83zhliyq5p.fsf@HIDDEN> <m34l3qovts.fsf@HIDDEN> <83y312yony.fsf@HIDDEN>
 <m3muhinff7.fsf@HIDDEN> <m3ims6nf9b.fsf@HIDDEN>
In-Reply-To: <m3ims6nf9b.fsf@HIDDEN>
Accept-Language: sv-SE, en-US
Content-Language: en-US
X-MS-Has-Attach: 
X-MS-TNEF-Correlator: 
x-clientproxiedby: HE1PR05CA0257.eurprd05.prod.outlook.com
 (2603:10a6:3:fb::33) To AM0PR09MB2867.eurprd09.prod.outlook.com
 (2603:10a6:208:134::10)
x-incomingtopheadermarker: OriginalChecksum:B07E7B27D6DA2A4C74E77BFCADC341074F32C8F53A847C8BE7FB4802D7DD92EA;
 UpperCasedChecksum:C865240418D546C49DD2C8D5C694DCB6C98CF81E4CD873C594E1FB04B7F77061;
 SizeAsReceived:8025; Count:49
x-ms-exchange-messagesentrepresentingtype: 1
x-tmn: [QszIW09ojq+KV0cuMzhSBnvepY4Fwqr3]
x-microsoft-original-message-id: <212543e1-25e4-906d-4f83-1db53e3653e2@HIDDEN>
x-ms-publictraffictype: Email
x-incomingheadercount: 49
x-eopattributedmessage: 0
x-microsoft-antispam: BCL:0; PCL:0;
 RULEID:(2390118)(5050001)(7020095)(20181119110)(201702061078)(5061506573)(5061507331)(1603103135)(2017031320274)(2017031323274)(2017031324274)(2017031322404)(1601125500)(1603101475)(1701031045);
 SRVR:DB5EUR03HT090; 
x-ms-traffictypediagnostic: DB5EUR03HT090:
x-microsoft-antispam-message-info: ec8TZNA29uV6il9KhCSQkoPXEEQq8lnMx81jia/IYo/a/fS6c8o2/ycGH0QNVttvDTpFEY5sl+I0Ggn6TU96x/tXLHKWNZ0zZ5jSxSp/NMqNEZzelcMlQ0m+Mipo59vFmV+/Mwc4CE8PszTZhLPzwK540B5GF8JAQjXi1N5H9qxpC/0cTBSPzMAKc8TP721r
Content-Type: text/plain; charset="Windows-1252"
Content-ID: <A38BD24A2AB1CC418C6F24D5F5D90B6F@HIDDEN>
Content-Transfer-Encoding: quoted-printable
MIME-Version: 1.0
X-OriginatorOrg: outlook.com
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-CrossTenant-Network-Message-Id: af016f47-0576-4877-5763-08d707a818ee
X-MS-Exchange-CrossTenant-rms-persistedconsumerorg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-CrossTenant-originalarrivaltime: 13 Jul 2019 15:38:05.5854 (UTC)
X-MS-Exchange-CrossTenant-fromentityheader: Internet
X-MS-Exchange-CrossTenant-id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-Transport-CrossTenantHeadersStamped: DB5EUR03HT090
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36550
Cc: "36550 <at> debbugs.gnu.org" <36550 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Den 2019-07-13 kl. 17:08, skrev Lars Ingebrigtsen:
> Lars Ingebrigtsen <larsi@HIDDEN> writes:
>=20
>> Eli Zaretskii <eliz@HIDDEN> writes:
>>
>>> OK, but then they simply should use a separate overlay for the
>>> mouse-face, I think, one that doesn't cover the newline.  Does that
>>> solve the problem?
>>
>> Yes, I can hack wid-edit.el as previously suggested.
>=20
> OK, I took another look at the wid-edit.el code which reminded me that
> it's not that simple, because it does a lot of manipulation of the
> overlays in the most tedious way.
>=20
> So I'll just leave this for somebody else to fix one rainy day...

I might have misunderstood the discussion, but just to clarify my=20
opinion, if the overlay ends with a newline character, the mouse-face=20
should *not* extend to the right edge of the window (and definitely not=20
to the first character on the next line). I would expect it to end after=20
the last character before the newline, or possibly one character further=20
to the right (as if there was an imaginary space character inserted=20
there). As was said earlier, it doesn't make sense to highlight parts of=20
a line that doesn't contain clickable text.

In recentf, the newline after the file name is included in each link so=20
that if point is positioned right after the last character -- which=20
happens, e.g., if one i-searches for a file extension -- one can simply=20
press enter to open the file (as said in the commit message). However,=20
due to the "bug" in question (if it is indeed a bug), when hovering the=20
mouse over a link, the whole line (up to the right edge of the window)=20
and the first character on the next line is highlighted. I have been=20
using Emacs, and the recentf package, for only five years, but I always=20
thought that this looked ugly and somewhat "buggy". The other day I was=20
a bit cranky and decided to look into it :-)

As I said earlier, one way to fix the issue in recentf is simply to move=20
the newline outside of the link, but put a space character after each=20
file name. This way, the mouse-over highlights look okay, and one can=20
still i-search for a file extension and then simply press enter. Here is=20
a patch that does this:

diff --git "a/lisp/recentf.el" "b/lisp/recentf.el"
index 4112b44e48..5d832a9d37 100644
--- "a/lisp/recentf.el"
+++ "b/lisp/recentf.el"
@@ -1179,9 +1179,9 @@ IGNORE other arguments."
      ;; Represent a single file with a link widget
      `(link :tag ,(car menu-element)
             :button-prefix ""
-           :button-suffix ""
+           :button-suffix " "
             :button-face default
-           :format "%[%t\n%]"
+           :format "%[%t%]\n"
             :help-echo ,(concat "Open " (cdr menu-element))
             :action recentf-open-files-action
             ;; Override the (problematic) follow-link property of the

Best regards,
Linus K=E4llberg




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36550; Package emacs. Full text available.

Message received at 36550 <at> debbugs.gnu.org:


Received: (at 36550) by debbugs.gnu.org; 13 Jul 2019 15:08:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 13 11:08:55 2019
Received: from localhost ([127.0.0.1]:43116 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hmJdv-0005pb-M9
	for submit <at> debbugs.gnu.org; Sat, 13 Jul 2019 11:08:55 -0400
Received: from quimby.gnus.org ([80.91.231.51]:35582)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hmJdt-0005pT-GF
 for 36550 <at> debbugs.gnu.org; Sat, 13 Jul 2019 11:08:54 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hmJdo-0001fJ-SF; Sat, 13 Jul 2019 17:08:52 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36550: mouse-face overlay calculation error
References: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
 <87v9wc2t8p.fsf@HIDDEN>
 <AM0PR09MB2867529A5BCE4551365F142C87F60@HIDDEN>
 <m3bly3xsto.fsf@HIDDEN>
 <AM0PR09MB2867803F96B1A7F4A5B4C81687F30@HIDDEN>
 <m3v9w6rd0s.fsf_-_@HIDDEN> <831ryu31fc.fsf@HIDDEN>
 <m336jaqdw2.fsf@HIDDEN> <834l3q132a.fsf@HIDDEN>
 <m3d0ieoxfy.fsf@HIDDEN> <83zhliyq5p.fsf@HIDDEN>
 <m34l3qovts.fsf@HIDDEN> <83y312yony.fsf@HIDDEN>
 <m3muhinff7.fsf@HIDDEN>
Date: Sat, 13 Jul 2019 17:08:48 +0200
In-Reply-To: <m3muhinff7.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Sat,
 13 Jul 2019 17:05:16 +0200")
Message-ID: <m3ims6nf9b.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Lars Ingebrigtsen <larsi@HIDDEN> writes: > Eli Zaretskii
 <eliz@HIDDEN> writes: > >> OK, but then they simply should use a separate
 overlay for the >> mouse-face, I think, one that doesn't cover the newline.
 Does that >> solve the problem? > [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36550
Cc: 36550 <at> debbugs.gnu.org, linus.kallberg@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> Eli Zaretskii <eliz@HIDDEN> writes:
>
>> OK, but then they simply should use a separate overlay for the
>> mouse-face, I think, one that doesn't cover the newline.  Does that
>> solve the problem?
>
> Yes, I can hack wid-edit.el as previously suggested.

OK, I took another look at the wid-edit.el code which reminded me that
it's not that simple, because it does a lot of manipulation of the
overlays in the most tedious way.

So I'll just leave this for somebody else to fix one rainy day...

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36550; Package emacs. Full text available.

Message received at 36550 <at> debbugs.gnu.org:


Received: (at 36550) by debbugs.gnu.org; 13 Jul 2019 15:05:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 13 11:05:22 2019
Received: from localhost ([127.0.0.1]:43111 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hmJaU-0005k7-6d
	for submit <at> debbugs.gnu.org; Sat, 13 Jul 2019 11:05:22 -0400
Received: from quimby.gnus.org ([80.91.231.51]:35478)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hmJaS-0005jx-QY
 for 36550 <at> debbugs.gnu.org; Sat, 13 Jul 2019 11:05:21 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hmJaO-0001en-Od; Sat, 13 Jul 2019 17:05:19 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36550: mouse-face overlay calculation error
References: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
 <87v9wc2t8p.fsf@HIDDEN>
 <AM0PR09MB2867529A5BCE4551365F142C87F60@HIDDEN>
 <m3bly3xsto.fsf@HIDDEN>
 <AM0PR09MB2867803F96B1A7F4A5B4C81687F30@HIDDEN>
 <m3v9w6rd0s.fsf_-_@HIDDEN> <831ryu31fc.fsf@HIDDEN>
 <m336jaqdw2.fsf@HIDDEN> <834l3q132a.fsf@HIDDEN>
 <m3d0ieoxfy.fsf@HIDDEN> <83zhliyq5p.fsf@HIDDEN>
 <m34l3qovts.fsf@HIDDEN> <83y312yony.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAGFBMVEUHARQQAh8BAAVcPVE2
 CSs0BCUGARIiAiLe6hVeAAACeUlEQVQ4jW2US3ebMBBGBfWRt5Ltg7dkEsQ2riDZloDdbRpHZSsU
 d7x14tff70jYaeJ0NnB05/HNaIDp/1vB5Ceb9I+maS7ACddfQFEF0DQVC6S4iKjkJICdPl5mowgm
 G0M5LwmB4dI8m68AbbRsGl1KKaJPwCGrm1oXPrY/iYIDA4W13upCMO6JIC56AKibZ138YhyZoHPe
 Z/Sg9sMxHNGSO4FTKrBhanOOCgNgZ5D2QKAKJKHAqAch1bzllNVahkjYEmjzAAqzcaQwQg+4jRiY
 P6e7aX0Vy9ERIRlLN9flsgd0xJkXRy2x5dzcm63PNfe+2x+cClF5ti3b38b4iCf1iF1Ies+oxkuJ
 62ztI/b4iN/6cgmpui4fIN+TsPKFeh/rIDFhkmVPoDLjwTWBWs8OY60XXi4oyHyNMuO8q8f6NtKT
 ivnOM5W1dWOecs7sOEy2ngkCMeQUMd8vqDsbTW8BeLPxgCwzRQtWISZSy0gmUy58jRyyvTk6GiFS
 qsErGy5EJFgKR8hNuQemIh5N80WXJAdBVwwwzIatbiGRSPLXsQOMRFgGd3MHz4uDG3NJ8/45gtRu
 qIZq4eb7unx7i8UgkgNcHVa7qZxSxBuAg4ecGo2d6368bvCow8K5IcCKNIFSMVwNZwec0JIRoJHA
 CILR+8sdYjdD1jcY7MrREJR9oPtF3r32QJ1pbncuxQGrdh7EH9jNRqWrarVh/1KdjTwmCS3Kx7PE
 Hmj/HBz8bgF6qdAFcjSY340exW4y9CNJE/LzML7CiMcoZScoIpXi1IZyq/ffg7+PFN+LnD7zEYZl
 +CDoBOhLEO8gaOjBOKEyLD4D/1KdgJXyL6mawm1Ql9iqAAAAAElFTkSuQmCC
Date: Sat, 13 Jul 2019 17:05:16 +0200
In-Reply-To: <83y312yony.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 13 Jul
 2019 17:50:09 +0300")
Message-ID: <m3muhinff7.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: > OK,
 but then they simply
 should use a separate overlay for the > mouse-face, I think, one that doesn't
 cover the newline. Does that > solve the problem? Yes, I can hack wid-edit.el
 as previously suggested. 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36550
Cc: 36550 <at> debbugs.gnu.org, linus.kallberg@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> OK, but then they simply should use a separate overlay for the
> mouse-face, I think, one that doesn't cover the newline.  Does that
> solve the problem?

Yes, I can hack wid-edit.el as previously suggested.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36550; Package emacs. Full text available.

Message received at 36550 <at> debbugs.gnu.org:


Received: (at 36550) by debbugs.gnu.org; 13 Jul 2019 14:50:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 13 10:50:41 2019
Received: from localhost ([127.0.0.1]:43072 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hmJMG-0003AY-SU
	for submit <at> debbugs.gnu.org; Sat, 13 Jul 2019 10:50:41 -0400
Received: from eggs.gnu.org ([209.51.188.92]:38586)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hmJMF-0003AL-5m
 for 36550 <at> debbugs.gnu.org; Sat, 13 Jul 2019 10:50:39 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:35868)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hmJM4-0002hO-El; Sat, 13 Jul 2019 10:50:29 -0400
Received: from [176.228.60.248] (port=2717 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hmJLx-0001M7-I8; Sat, 13 Jul 2019 10:50:24 -0400
Date: Sat, 13 Jul 2019 17:50:09 +0300
Message-Id: <83y312yony.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <m34l3qovts.fsf@HIDDEN> (message from Lars Ingebrigtsen on Sat, 
 13 Jul 2019 16:25:35 +0200)
Subject: Re: bug#36550: mouse-face overlay calculation error
References: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
 <87v9wc2t8p.fsf@HIDDEN>
 <AM0PR09MB2867529A5BCE4551365F142C87F60@HIDDEN>
 <m3bly3xsto.fsf@HIDDEN>
 <AM0PR09MB2867803F96B1A7F4A5B4C81687F30@HIDDEN>
 <m3v9w6rd0s.fsf_-_@HIDDEN> <831ryu31fc.fsf@HIDDEN>
 <m336jaqdw2.fsf@HIDDEN> <834l3q132a.fsf@HIDDEN>
 <m3d0ieoxfy.fsf@HIDDEN> <83zhliyq5p.fsf@HIDDEN> <m34l3qovts.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36550
Cc: 36550 <at> debbugs.gnu.org, linus.kallberg@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: 36550 <at> debbugs.gnu.org,  linus.kallberg@HIDDEN
> Date: Sat, 13 Jul 2019 16:25:35 +0200
> 
> > And what point has to do with that, since mouse-face is about the
> > mouse pointer, not about point?  What am I missing here?
> 
> The widget consists of text in the buffer and a bunch of overlays
> (including keymap overlays), and the mouse-face overlay is one of them.
> My guess is that the committer wanted the keymap to be on the newline so
> that it's in effect when typing?

OK, but then they simply should use a separate overlay for the
mouse-face, I think, one that doesn't cover the newline.  Does that
solve the problem?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36550; Package emacs. Full text available.

Message received at 36550 <at> debbugs.gnu.org:


Received: (at 36550) by debbugs.gnu.org; 13 Jul 2019 14:25:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 13 10:25:50 2019
Received: from localhost ([127.0.0.1]:42998 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hmIyB-0006cW-9K
	for submit <at> debbugs.gnu.org; Sat, 13 Jul 2019 10:25:47 -0400
Received: from quimby.gnus.org ([80.91.231.51]:34656)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hmIy5-0006cH-Cp
 for 36550 <at> debbugs.gnu.org; Sat, 13 Jul 2019 10:25:44 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hmIxz-0001MU-K7; Sat, 13 Jul 2019 16:25:39 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36550: mouse-face overlay calculation error
References: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
 <87v9wc2t8p.fsf@HIDDEN>
 <AM0PR09MB2867529A5BCE4551365F142C87F60@HIDDEN>
 <m3bly3xsto.fsf@HIDDEN>
 <AM0PR09MB2867803F96B1A7F4A5B4C81687F30@HIDDEN>
 <m3v9w6rd0s.fsf_-_@HIDDEN> <831ryu31fc.fsf@HIDDEN>
 <m336jaqdw2.fsf@HIDDEN> <834l3q132a.fsf@HIDDEN>
 <m3d0ieoxfy.fsf@HIDDEN> <83zhliyq5p.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAGFBMVEUHARQQAh8BAAVcPVE2
 CSs0BCUGARIiAiLe6hVeAAACeUlEQVQ4jW2US3ebMBBGBfWRt5Ltg7dkEsQ2riDZloDdbRpHZSsU
 d7x14tff70jYaeJ0NnB05/HNaIDp/1vB5Ceb9I+maS7ACddfQFEF0DQVC6S4iKjkJICdPl5mowgm
 G0M5LwmB4dI8m68AbbRsGl1KKaJPwCGrm1oXPrY/iYIDA4W13upCMO6JIC56AKibZ138YhyZoHPe
 Z/Sg9sMxHNGSO4FTKrBhanOOCgNgZ5D2QKAKJKHAqAch1bzllNVahkjYEmjzAAqzcaQwQg+4jRiY
 P6e7aX0Vy9ERIRlLN9flsgd0xJkXRy2x5dzcm63PNfe+2x+cClF5ti3b38b4iCf1iF1Ies+oxkuJ
 62ztI/b4iN/6cgmpui4fIN+TsPKFeh/rIDFhkmVPoDLjwTWBWs8OY60XXi4oyHyNMuO8q8f6NtKT
 ivnOM5W1dWOecs7sOEy2ngkCMeQUMd8vqDsbTW8BeLPxgCwzRQtWISZSy0gmUy58jRyyvTk6GiFS
 qsErGy5EJFgKR8hNuQemIh5N80WXJAdBVwwwzIatbiGRSPLXsQOMRFgGd3MHz4uDG3NJ8/45gtRu
 qIZq4eb7unx7i8UgkgNcHVa7qZxSxBuAg4ecGo2d6368bvCow8K5IcCKNIFSMVwNZwec0JIRoJHA
 CILR+8sdYjdD1jcY7MrREJR9oPtF3r32QJ1pbncuxQGrdh7EH9jNRqWrarVh/1KdjTwmCS3Kx7PE
 Hmj/HBz8bgF6qdAFcjSY340exW4y9CNJE/LzML7CiMcoZScoIpXi1IZyq/ffg7+PFN+LnD7zEYZl
 +CDoBOhLEO8gaOjBOKEyLD4D/1KdgJXyL6mawm1Ql9iqAAAAAElFTkSuQmCC
Date: Sat, 13 Jul 2019 16:25:35 +0200
In-Reply-To: <83zhliyq5p.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 13 Jul
 2019 17:17:54 +0300")
Message-ID: <m34l3qovts.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: >> From: Lars
 Ingebrigtsen
 <larsi@HIDDEN> >> Cc: 36550 <at> debbugs.gnu.org, linus.kallberg@HIDDEN
 >> Date: Sat, 13 Jul 2019 15:50:41 +0200 >> >> commit
 5d24c60e3a3b07ccb31b886885ea117a058168be >> A [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36550
Cc: 36550 <at> debbugs.gnu.org, linus.kallberg@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Lars Ingebrigtsen <larsi@HIDDEN>
>> Cc: 36550 <at> debbugs.gnu.org,  linus.kallberg@HIDDEN
>> Date: Sat, 13 Jul 2019 15:50:41 +0200
>> 
>> commit 5d24c60e3a3b07ccb31b886885ea117a058168be
>> Author: David Ponce <david@HIDDEN>
>> Date:   Mon Apr 3 14:34:28 2006 +0000
>> 
>>     (recentf-open-files-item): Include newline in button
>>     field, so opening a file will work, when the point is at the end
>>     of the file name.  Allow, for example, to [i]search a file by
>>     extension and just push RET to open it.
>> 
>> So it really wants the widget to have the newline inside the widget for
>> usability reasons.
>
> I still don't understand why.  Surely, "the end of the file name" is
> before the newline, right?

I am not sure; I don't use recentf...

> And what point has to do with that, since mouse-face is about the
> mouse pointer, not about point?  What am I missing here?

The widget consists of text in the buffer and a bunch of overlays
(including keymap overlays), and the mouse-face overlay is one of them.
My guess is that the committer wanted the keymap to be on the newline so
that it's in effect when typing?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36550; Package emacs. Full text available.

Message received at 36550 <at> debbugs.gnu.org:


Received: (at 36550) by debbugs.gnu.org; 13 Jul 2019 14:18:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 13 10:18:20 2019
Received: from localhost ([127.0.0.1]:42979 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hmIqu-0006Oj-So
	for submit <at> debbugs.gnu.org; Sat, 13 Jul 2019 10:18:20 -0400
Received: from eggs.gnu.org ([209.51.188.92]:57991)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hmIqp-0006OP-PL
 for 36550 <at> debbugs.gnu.org; Sat, 13 Jul 2019 10:18:15 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:34671)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hmIqk-0000RD-G9; Sat, 13 Jul 2019 10:18:06 -0400
Received: from [176.228.60.248] (port=4730 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hmIqj-0008Bl-Lk; Sat, 13 Jul 2019 10:18:06 -0400
Date: Sat, 13 Jul 2019 17:17:54 +0300
Message-Id: <83zhliyq5p.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <m3d0ieoxfy.fsf@HIDDEN> (message from Lars Ingebrigtsen on Sat, 
 13 Jul 2019 15:50:41 +0200)
Subject: Re: bug#36550: mouse-face overlay calculation error
References: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
 <87v9wc2t8p.fsf@HIDDEN>
 <AM0PR09MB2867529A5BCE4551365F142C87F60@HIDDEN>
 <m3bly3xsto.fsf@HIDDEN>
 <AM0PR09MB2867803F96B1A7F4A5B4C81687F30@HIDDEN>
 <m3v9w6rd0s.fsf_-_@HIDDEN> <831ryu31fc.fsf@HIDDEN>
 <m336jaqdw2.fsf@HIDDEN> <834l3q132a.fsf@HIDDEN> <m3d0ieoxfy.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36550
Cc: 36550 <at> debbugs.gnu.org, linus.kallberg@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: 36550 <at> debbugs.gnu.org,  linus.kallberg@HIDDEN
> Date: Sat, 13 Jul 2019 15:50:41 +0200
> 
> commit 5d24c60e3a3b07ccb31b886885ea117a058168be
> Author: David Ponce <david@HIDDEN>
> Date:   Mon Apr 3 14:34:28 2006 +0000
> 
>     (recentf-open-files-item): Include newline in button
>     field, so opening a file will work, when the point is at the end
>     of the file name.  Allow, for example, to [i]search a file by
>     extension and just push RET to open it.
> 
> So it really wants the widget to have the newline inside the widget for
> usability reasons.

I still don't understand why.  Surely, "the end of the file name" is
before the newline, right?  And what point has to do with that, since
mouse-face is about the mouse pointer, not about point?  What am I
missing here?

> Well, it's not 100% right, since it highlights the first character on
> the next line if you have mouse-face on the preceding newline, which has
> to be a bug even if we're not supposed to put mouse-face on the newline.
> :-)

No, it's 100% right, because it implements a certain set of
requirements, and those mandate that when the end point is beyond the
last character on a line, that end point is in the next line.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36550; Package emacs. Full text available.

Message received at 36550 <at> debbugs.gnu.org:


Received: (at 36550) by debbugs.gnu.org; 13 Jul 2019 13:50:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 13 09:50:58 2019
Received: from localhost ([127.0.0.1]:41626 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hmIQQ-000366-Lu
	for submit <at> debbugs.gnu.org; Sat, 13 Jul 2019 09:50:58 -0400
Received: from quimby.gnus.org ([80.91.231.51]:34178)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hmIQK-00035s-D0
 for 36550 <at> debbugs.gnu.org; Sat, 13 Jul 2019 09:50:52 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hmIQE-00016R-42; Sat, 13 Jul 2019 15:50:46 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36550: mouse-face overlay calculation error
References: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
 <87v9wc2t8p.fsf@HIDDEN>
 <AM0PR09MB2867529A5BCE4551365F142C87F60@HIDDEN>
 <m3bly3xsto.fsf@HIDDEN>
 <AM0PR09MB2867803F96B1A7F4A5B4C81687F30@HIDDEN>
 <m3v9w6rd0s.fsf_-_@HIDDEN> <831ryu31fc.fsf@HIDDEN>
 <m336jaqdw2.fsf@HIDDEN> <834l3q132a.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwAgMAAAAqbBEUAAAADFBMVEVoSzWRfmBJMSUmFBJN
 q2pcAAACZ0lEQVQokR3QT0iTcQDG8ed9e98Ym9QYm2Betp3mDolEFwk3M8E/odPt3cSpg/BQElaH
 IELm71VnoqAReYgum2Bsr3OTTrrJZmIQeUjsDx1VZumEvf7BmE3fX6PLA5/Dc/lCz/YJfZJGOWdo
 FsQq2uf2WGVfTbcgSXyCZqT4uwP5FbIWoUB/hUPuAh1CatZFM6q/0x66yYLudk6dDiuG27bvGlDR
 Gz+3FZFeoTgXvFSxnQmtqbP/yBZsR0Jr/FAGFbzf6OCF4HNepEEDWq6mUhGa9MtpHAndoxW2j4Ze
 7UIaitAzwSS3hf5PnAyT0FpJFkKCv4asg6n1KRPbfL1f0ayB8D5Fbak3PMpbAsjzlSmjNzhty7+5
 j+uuGB1zLLUnlIp2tPf2K2HTg7KEEuKwoSqipE1MHgef4MQ3eatfs+Kvzi/aUHD+6O7x5FrKnj7z
 Iep25xx35rudS41OzHt0i55CVYf3qPMQgU7xoScT8PJVvg2U3jV1fdlre35z4KoJpdZ6r7zmMBpa
 4iKSUfYg/TL9WD1JXfhNRb88PpHkldQ9WGOqAflUWjYl4i9gSVcP7nPG5UjS+BrSSbYYSpIjdNaF
 oZMDmncPr8/RXQeGsgXZusmuy7loBy4dH4cRLM9+DpoB3Q5HXMa6n1rRxYAtXGYZ1O1pGaEWeB80
 hO3sKvSMHZjBSAwIs9pIEdLKSBzsONFFXAhCHFepCatXGe0Y030wNVnRPMsX/zMcmAYz0XKGRhZh
 LsgU1w2ugUXITFTNJEAIrwbMN3beThEySUquAGN/5kblBPs1Wh4j8OhzC9JW17Xoajb0D5SkFion
 jrTzAAAAAElFTkSuQmCC
Date: Sat, 13 Jul 2019 15:50:41 +0200
In-Reply-To: <834l3q132a.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 13 Jul
 2019 16:23:09 +0300")
Message-ID: <m3d0ieoxfy.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: > I don't understand
 why Widget would want to do that. As I explained,
 > it makes no sense to highlight
 parts of display that have no text with > a face that shows mouse-sensitive
 text. When the next [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36550
Cc: 36550 <at> debbugs.gnu.org, linus.kallberg@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> I don't understand why Widget would want to do that.  As I explained,
> it makes no sense to highlight parts of display that have no text with
> a face that shows mouse-sensitive text.  When the next line's
> characters are also sensitive, then yes, we do highlight all the way
> to the newline.

This is the commit that introduced the problem:

commit 5d24c60e3a3b07ccb31b886885ea117a058168be
Author: David Ponce <david@HIDDEN>
Date:   Mon Apr 3 14:34:28 2006 +0000

    (recentf-open-files-item): Include newline in button
    field, so opening a file will work, when the point is at the end
    of the file name.  Allow, for example, to [i]search a file by
    extension and just push RET to open it.

So it really wants the widget to have the newline inside the widget for
usability reasons.

I can special-case this in wid-edit.el -- if the final character in the
region is a newline, then all the other overlays extend all the way, but
mouse-face stops just short of the newline.  But it's more than a bit
hacky...

>> Oh, wow; that's a daunting function indeed...
>
> Yes.  The problem it tries to solve is to highlight correctly when
> buffer positions do not increment monotonously with screen
> coordinates.  Unsurprisingly, at the time it took me some time to get
> that code right.

I see.

Well, it's not 100% right, since it highlights the first character on
the next line if you have mouse-face on the preceding newline, which has
to be a bug even if we're not supposed to put mouse-face on the newline.
:-)

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36550; Package emacs. Full text available.

Message received at 36550 <at> debbugs.gnu.org:


Received: (at 36550) by debbugs.gnu.org; 13 Jul 2019 13:23:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 13 09:23:29 2019
Received: from localhost ([127.0.0.1]:41613 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hmHzs-0002SN-M6
	for submit <at> debbugs.gnu.org; Sat, 13 Jul 2019 09:23:28 -0400
Received: from eggs.gnu.org ([209.51.188.92]:38883)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hmHzr-0002SA-0w
 for 36550 <at> debbugs.gnu.org; Sat, 13 Jul 2019 09:23:27 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:33610)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hmHzk-0006Je-Dk; Sat, 13 Jul 2019 09:23:21 -0400
Received: from [176.228.60.248] (port=1398 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hmHzj-0002bJ-SD; Sat, 13 Jul 2019 09:23:20 -0400
Date: Sat, 13 Jul 2019 16:23:09 +0300
Message-Id: <834l3q132a.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <m336jaqdw2.fsf@HIDDEN> (message from Lars Ingebrigtsen on Sat, 
 13 Jul 2019 15:10:05 +0200)
Subject: Re: bug#36550: mouse-face overlay calculation error
References: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
 <87v9wc2t8p.fsf@HIDDEN>
 <AM0PR09MB2867529A5BCE4551365F142C87F60@HIDDEN>
 <m3bly3xsto.fsf@HIDDEN>
 <AM0PR09MB2867803F96B1A7F4A5B4C81687F30@HIDDEN>
 <m3v9w6rd0s.fsf_-_@HIDDEN> <831ryu31fc.fsf@HIDDEN>
 <m336jaqdw2.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36550
Cc: 36550 <at> debbugs.gnu.org, linus.kallberg@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: 36550 <at> debbugs.gnu.org,  linus.kallberg@HIDDEN
> Date: Sat, 13 Jul 2019 15:10:05 +0200
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > Mouse-face isn't supposed to cover newlines, I think.  Why do you need
> > that?
> 
> Because Widget wants to have the mouse-face extend to the end of the
> line, I think...

I don't understand why Widget would want to do that.  As I explained,
it makes no sense to highlight parts of display that have no text with
a face that shows mouse-sensitive text.  When the next line's
characters are also sensitive, then yes, we do highlight all the way
to the newline.

> > The "one character shorter" variant does what it's expected to do,
> > because mouse-face is not extended to EOL as with other faces.
> > Mouse-face is for showing the parts of text that are mouse-sensitive,
> > so it makes no sense to highlight portions of display that have no
> > text.
> 
> OK, if this is how mouse-face is supposed to work, then the fix in
> wid-edit.el should be pretty trivial -- I'll just have it not put the
> overlay on the newline?

Yes, I think so.

> > It's in the display code, and is quite complicated due to
> > bidirectional text use case.  See mouse_face_from_buffer_pos and its
> > subroutine rows_from_pos_range.
> 
> Oh, wow; that's a daunting function indeed...

Yes.  The problem it tries to solve is to highlight correctly when
buffer positions do not increment monotonously with screen
coordinates.  Unsurprisingly, at the time it took me some time to get
that code right.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36550; Package emacs. Full text available.

Message received at 36550 <at> debbugs.gnu.org:


Received: (at 36550) by debbugs.gnu.org; 13 Jul 2019 13:10:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 13 09:10:13 2019
Received: from localhost ([127.0.0.1]:41597 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hmHn2-00025a-Pe
	for submit <at> debbugs.gnu.org; Sat, 13 Jul 2019 09:10:13 -0400
Received: from quimby.gnus.org ([80.91.231.51]:33376)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hmHn0-00025P-SV
 for 36550 <at> debbugs.gnu.org; Sat, 13 Jul 2019 09:10:11 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hmHmv-0000nq-BT; Sat, 13 Jul 2019 15:10:07 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36550: mouse-face overlay calculation error
References: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
 <87v9wc2t8p.fsf@HIDDEN>
 <AM0PR09MB2867529A5BCE4551365F142C87F60@HIDDEN>
 <m3bly3xsto.fsf@HIDDEN>
 <AM0PR09MB2867803F96B1A7F4A5B4C81687F30@HIDDEN>
 <m3v9w6rd0s.fsf_-_@HIDDEN> <831ryu31fc.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAGFBMVEUFBhFecKcPGUICAw0H
 CRUdLXALECkJDBx/kThDAAACLElEQVQ4jV3UTW/jIBAGYNSw27NX4r4ayeRqiaq5Rlu0vjZWSe9s
 Mr5GCoG/v+9gk344t3kyzDBgq7LfK19y7EPoui4E4uKV8i9KOaXHwjGEA8AEsnNJHuCc8gBqMBHP
 pUiGxHOkGsdaH+B9qdCtYJlLSS/qMTMRfwLJSIAHg5DlBgYZUv1F/ZziRPkbSFeaE2pwfwda4SGc
 xm9QKiiNdktd6vAFHiPRdgEZCmrISoAfIZg3mZXAwRiMJHndwKMI4iKonT4yAOfv8HAHA+iMZSkh
 GwzR/saBrBkB+1thekXLJd8qhCAZSoorA1C5NGA++X2F7g3wd74dGtQaV6UOrwuEBtKU3wMkY0w3
 mvoep7Gd034BPgF0ulmiPmA8OcmpXpQ2vdm4x3QWIJlb0XqBziBjf8a/qQIm5T3STNcBLmesj2d6
 L7UGAIegnGQ0kIxRMkxwrmX0od5DXwB4Nhvvua/A8wgYV1CD9kwRXdloBXwS2DjnnhQTLh5ZtiM6
 rcUl7obBWmwkAhDTtbgaKmzZxhW0WkBShqet5XjMACwv1QFuBRuPDPUNNiLD7jQTdmJLTr7ewZax
 O2kZoi1/0vhlqR3zHHsUz6mOpIF6joAJwBct+5AamwaZ8csAOal1g06g5BF0GeQNuMMOq8jOM18H
 OWq/lACQ7Q/H8y+KVydj9Wu8QqCI871Kk58gn0N9cbb/vsJz/cjIhZ9m6bJBpvDx0ElqDEu8v0fx
 nZjR6X/Glg5bq1IKowAAAABJRU5ErkJggg==
Date: Sat, 13 Jul 2019 15:10:05 +0200
In-Reply-To: <831ryu31fc.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 13 Jul
 2019 09:15:35 +0300")
Message-ID: <m336jaqdw2.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: > Mouse-face isn't
 supposed
 to cover newlines, I think. Why do you need > that? Because Widget wants
 to have the mouse-face extend to the end of the line, I think... 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36550
Cc: 36550 <at> debbugs.gnu.org, linus.kallberg@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> Mouse-face isn't supposed to cover newlines, I think.  Why do you need
> that?

Because Widget wants to have the mouse-face extend to the end of the
line, I think...

> The "one character shorter" variant does what it's expected to do,
> because mouse-face is not extended to EOL as with other faces.
> Mouse-face is for showing the parts of text that are mouse-sensitive,
> so it makes no sense to highlight portions of display that have no
> text.

OK, if this is how mouse-face is supposed to work, then the fix in
wid-edit.el should be pretty trivial -- I'll just have it not put the
overlay on the newline?

>> So is there some basic fault in the code that calculates the length of
>> the mouse highlighting?  I don't really know where to start looking...
>
> It's in the display code, and is quite complicated due to
> bidirectional text use case.  See mouse_face_from_buffer_pos and its
> subroutine rows_from_pos_range.

Oh, wow; that's a daunting function indeed...

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36550; Package emacs. Full text available.

Message received at 36550 <at> debbugs.gnu.org:


Received: (at 36550) by debbugs.gnu.org; 13 Jul 2019 06:15:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 13 02:15:51 2019
Received: from localhost ([127.0.0.1]:41346 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hmBK3-0001QX-5M
	for submit <at> debbugs.gnu.org; Sat, 13 Jul 2019 02:15:51 -0400
Received: from eggs.gnu.org ([209.51.188.92]:50183)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hmBK0-0001QG-P8
 for 36550 <at> debbugs.gnu.org; Sat, 13 Jul 2019 02:15:49 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:57379)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hmBJv-0002hd-7b; Sat, 13 Jul 2019 02:15:43 -0400
Received: from [176.228.60.248] (port=2214 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hmBJu-0001AF-N7; Sat, 13 Jul 2019 02:15:43 -0400
Date: Sat, 13 Jul 2019 09:15:35 +0300
Message-Id: <831ryu31fc.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <m3v9w6rd0s.fsf_-_@HIDDEN> (message from Lars Ingebrigtsen on
 Sat, 13 Jul 2019 02:31:15 +0200)
Subject: Re: bug#36550: mouse-face overlay calculation error
References: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
 <87v9wc2t8p.fsf@HIDDEN>
 <AM0PR09MB2867529A5BCE4551365F142C87F60@HIDDEN>
 <m3bly3xsto.fsf@HIDDEN>
 <AM0PR09MB2867803F96B1A7F4A5B4C81687F30@HIDDEN>
 <m3v9w6rd0s.fsf_-_@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36550
Cc: 36550 <at> debbugs.gnu.org, linus.kallberg@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Date: Sat, 13 Jul 2019 02:31:15 +0200
> Cc: "36550 <at> debbugs.gnu.org" <36550 <at> debbugs.gnu.org>
> 
> (progn
>   (let ((point (point)))
>     (insert "foo\n")
>     (let ((o (make-overlay point (point))))
>       (overlay-put o 'mouse-face 'highlight)
>       (insert "bar"))))
> 
> This should make a mouse face that's displayed the entire "foo" line,
> but it extends to the first character of the next line.
> 
> If you make it one character shorter, then the entire line isn't
> highlighted.
> 
> And!  If you say `face' instead of `mouse-face', then everything is
> highlighted correctly (i.e., just the entire "foo" line, and not the "b"
> on the next line).

Mouse-face isn't supposed to cover newlines, I think.  Why do you need
that?

The "one character shorter" variant does what it's expected to do,
because mouse-face is not extended to EOL as with other faces.
Mouse-face is for showing the parts of text that are mouse-sensitive,
so it makes no sense to highlight portions of display that have no
text.

> So is there some basic fault in the code that calculates the length of
> the mouse highlighting?  I don't really know where to start looking...

It's in the display code, and is quite complicated due to
bidirectional text use case.  See mouse_face_from_buffer_pos and its
subroutine rows_from_pos_range.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36550; Package emacs. Full text available.

Message received at 36550 <at> debbugs.gnu.org:


Received: (at 36550) by debbugs.gnu.org; 13 Jul 2019 00:31:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jul 12 20:31:22 2019
Received: from localhost ([127.0.0.1]:40979 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hm5wg-00007Z-0D
	for submit <at> debbugs.gnu.org; Fri, 12 Jul 2019 20:31:22 -0400
Received: from quimby.gnus.org ([80.91.231.51]:51974)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hm5wd-00007Q-S3
 for 36550 <at> debbugs.gnu.org; Fri, 12 Jul 2019 20:31:20 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hm5wZ-0003QU-9O; Sat, 13 Jul 2019 02:31:17 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Linus =?utf-8?Q?K=C3=A4llberg?= <linus.kallberg@HIDDEN>
Subject: Re: bug#36550: mouse-face overlay calculation error
References: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
 <87v9wc2t8p.fsf@HIDDEN>
 <AM0PR09MB2867529A5BCE4551365F142C87F60@HIDDEN>
 <m3bly3xsto.fsf@HIDDEN>
 <AM0PR09MB2867803F96B1A7F4A5B4C81687F30@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAD1BMVEXw59EbCgKWeFNZNhm/
 poHSBlJ6AAACRklEQVQ4jXWT4ZHrIAyEFUwBh7kCMFBAQC6Ak+m/preLnZv785iMk/jTSiAtIv9d
 ySSl4aR6GfL2w7tNJn5KcgDixAg84hxjqXAzVSjMIDIZzomzv4rqx/BeHIDPkgAgr8OLH3NOZAcU
 Cjz+jmkZTz6wMleSK4QQS2uqHT+yaQ5cX7JpC0H7sRdG5CPEX6Ah7LPEEhQLUe2PInpdr7lCiwh9
 34ow3wfjYutAvV5dxKlBcvbjzr1EuUyCiuDvvDIjTSxaOgSytW/fQi/hWZGSPgii/LRphRU+IKch
 W29vOaazFjM3uKpk+5LX233LlXzB6XK5QTztLS+8Hi4JkvR5sQvaYrUkWxw+ocULmLJI29lE7062
 2Ye9nj7PxurdMifksDfx8Q2aeSaAnIe8ztsTbXwOi+qlQ6FI9wC/9WOdpCdmMT5EB77s/AGIpVdE
 DX4A0uTXxVQlz5Xe81WpS/jDRpqy4PIDQKkEqNFQG6EvtJhKdynFLWiItZwAOIAxeHITtoA25HqF
 KI79N1bCvJQz3wla8ujA2psjoE9wuBcc4ViY7GAT6ay8wL5NJ9eOKmuEDRQt2eiydF0NrcMEMV6C
 uYojoGhHTc6dM8SGBdtdru4FKdrHKnulS5ZpukJ1W467XanufxjOLaBDd0sPiBG1H8f1bP0XUPKY
 UavhUn19FMhbPgLcNv2+Qcz026rRc524RucNtJ0tLB/2WmedrT0gOwx7FVkX12K5U0W1060iWhfo
 j6JrgXlRBC5d4MAddCuGE5y3XZ71D0wOgmbyTAhxAAAAAElFTkSuQmCC
Date: Sat, 13 Jul 2019 02:31:15 +0200
In-Reply-To: <AM0PR09MB2867803F96B1A7F4A5B4C81687F30@HIDDEN>
 ("Linus \=\?utf-8\?Q\?K\=C3\=A4llberg\=22's\?\= message of "Thu, 11 Jul 2019
 16:34:29 +0000")
Message-ID: <m3v9w6rd0s.fsf_-_@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 
 Content preview:  Linus Källberg <linus.kallberg@HIDDEN> writes: > On
   second thought, I don't think the real problem is in recentf.el, but > rather
    in the implementation of widgets and/or faces. It makes sense to > keep recentf.el
    as it is. 
 
 Content analysis details:   (-2.9 points, 5.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
                             [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36550
Cc: "36550 <at> debbugs.gnu.org" <36550 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Linus K=C3=A4llberg <linus.kallberg@HIDDEN> writes:

> On second thought, I don't think the real problem is in recentf.el, but=20
> rather in the implementation of widgets and/or faces. It makes sense to=20
> keep recentf.el as it is.

There's something even more fundamentally wrong going on here, I think.

Here's a test case:

(progn
  (let ((point (point)))
    (insert "foo\n")
    (let ((o (make-overlay point (point))))
      (overlay-put o 'mouse-face 'highlight)
      (insert "bar"))))

This should make a mouse face that's displayed the entire "foo" line,
but it extends to the first character of the next line.

If you make it one character shorter, then the entire line isn't
highlighted.

And!  If you say `face' instead of `mouse-face', then everything is
highlighted correctly (i.e., just the entire "foo" line, and not the "b"
on the next line).

So is there some basic fault in the code that calculates the length of
the mouse highlighting?  I don't really know where to start looking...

--=20
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36550; Package emacs. Full text available.

Message received at 36550 <at> debbugs.gnu.org:


Received: (at 36550) by debbugs.gnu.org; 12 Jul 2019 15:07:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jul 12 11:07:10 2019
Received: from localhost ([127.0.0.1]:40547 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hlx8g-0002Xb-0X
	for submit <at> debbugs.gnu.org; Fri, 12 Jul 2019 11:07:10 -0400
Received: from quimby.gnus.org ([80.91.231.51]:45996)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hlx8e-0002XT-CQ
 for 36550 <at> debbugs.gnu.org; Fri, 12 Jul 2019 11:07:08 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hlx8a-0007Cq-3b; Fri, 12 Jul 2019 17:07:06 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Linus =?utf-8?Q?K=C3=A4llberg?= <linus.kallberg@HIDDEN>
Subject: Re: bug#36550: Small bug fix in recentf.el
References: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
 <87v9wc2t8p.fsf@HIDDEN>
 <AM0PR09MB2867529A5BCE4551365F142C87F60@HIDDEN>
 <m3bly3xsto.fsf@HIDDEN>
 <AM0PR09MB2867803F96B1A7F4A5B4C81687F30@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAD1BMVEX+/gfj2Qr//whAOgT/
 /wkKSUWSAAACfklEQVQ4jU2U2xmkIAyFI04BXCwgRAogxgIU6b+mPXFm91teUH5zOwmStFvnfLY5
 47xPPGkqPfNCInPdHNzbHMAWRKK2F+DDJ0vbZORZVeaQNF4gOvcc7kMktP0AGHIt1GSytj3TcjCF
 zx7DnLMhRmtCRfbIoWSisMbPnMMBPFKhPVKolimUSENEAIawA5xJNbegazQRDy5shHesPYubSruQ
 1RQi5dX9cz3G2olFylbJzfByUCKpGc8BwMaN4Aw/9WBlhisxmIqKg1sFADlLIeFVufbPrJTMs1wO
 WjX1EIjMrDeAYhvyQeKmCaUXpRTFgZlGB9ViyYFMySAaggNYCIjSZe0cfuBrYZ0kAEDyqv0Lbsqs
 pgzVOuqT2h1wa5fXYQZ1ag9lk/0FCO5AiqEwaGsiazzFTplfsH5BACghih3TgbQBEGRRnIrJEux8
 wQxcLIqntOZmvGQ7m4PBYiiEAPZ8Q6i/gARqoVkAz1EBjp8rL1C9yX3U/uDt/A9g2qQe7dLnnLdC
 Xvu8IAnAfrRm6waXDqC4p8TUJmMsrpKZ0wsu2jAmkBCJ4SR9oF+BD7g6hDmEvWTxL9UFwobgBwdm
 SUvGBEwpudrP1QlHIvrk5hfgPssLFACDxU2fo+FiydRiHVEMYMCinmiSDgArhvLMIh0+3Pt56YRF
 m6Vgg0n0GDKebejXVSku4YMxQOelrdsoTdHgATC/4BQeoyDRD6R8XbWvK4zOGNZwoQFme4NfHryH
 EaalVE7/9E33Wj1dTSn5INvp6dz9X4Hv1j+QW1vjEpe/krx7D3Sp+1Pvw1fE1xTzfnkffPBxAnzR
 dy3pt+Jvv35oWRbcTkIevvBzmH8AXd+kTBu5Ba4AAAAASUVORK5CYII=
Date: Fri, 12 Jul 2019 17:07:03 +0200
In-Reply-To: <AM0PR09MB2867803F96B1A7F4A5B4C81687F30@HIDDEN>
 ("Linus \=\?utf-8\?Q\?K\=C3\=A4llberg\=22's\?\= message of "Thu, 11 Jul 2019
 16:34:29 +0000")
Message-ID: <m3a7djthpk.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 
 Content preview:  Linus Källberg <linus.kallberg@HIDDEN> writes: > On
   second thought, I don't think the real problem is in recentf.el, but > rather
    in the implementation of widgets and/or faces. It makes sense to > keep recentf.el
    as it is. > > I'm probably not qua [...] 
 
 Content analysis details:   (-2.9 points, 5.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
                             [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36550
Cc: "36550 <at> debbugs.gnu.org" <36550 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Linus K=C3=A4llberg <linus.kallberg@HIDDEN> writes:

> On second thought, I don't think the real problem is in recentf.el, but=20
> rather in the implementation of widgets and/or faces. It makes sense to=20
> keep recentf.el as it is.
>
> I'm probably not qualified to fix the bug, at least in a timely manner,=20
> but I did some experimenting and came up with an MWE, which is attached=20
> to this e-mail. Hopefully it can be of some help.

Yes, thanks for the examples -- widget.el is clearly placing the mouse
highlights wrong here; the most important being the "highlight the first
character on the next line", but the EOF thing was also pretty curious,
and is probably more an Emacs quirk than a widget.el bug...

--=20
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36550; Package emacs. Full text available.

Message received at 36550 <at> debbugs.gnu.org:


Received: (at 36550) by debbugs.gnu.org; 11 Jul 2019 16:36:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jul 11 12:36:24 2019
Received: from localhost ([127.0.0.1]:38522 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hlc3U-0003m9-7o
	for submit <at> debbugs.gnu.org; Thu, 11 Jul 2019 12:36:24 -0400
Received: from mail-oln040092069056.outbound.protection.outlook.com
 ([40.92.69.56]:11534 helo=EUR02-VE1-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <linus.kallberg@HIDDEN>) id 1hlc1k-0003j6-Q2
 for 36550 <at> debbugs.gnu.org; Thu, 11 Jul 2019 12:34:37 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=outlook.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=CUAq3TyaSF5Ss+aurIssBwF47/kYt6Cmg39hZPwDCSA=;
 b=aUCfROG2aK9cWOOCHTFkoi9qEfy3VXkaDUi9rVxkJKKAYdRHdtn9kUgEmd0lyO8N/+5TbVDECSI+GUcf25TYAnliY3oTLBDqkke5W+rUFe/7Htc0On/d3ML/2zjTyXWalY3WmwULg4H1wv5bdTNUvu9TxhafQh/zJLWMnpJHvQ6UOv3qUC8Wp+kGEGIDxA5tMrYRLUx43LSYcnmlL2Z1nq9vLLt8EAkBHyIvPhkYxzLZbNY12EKZxYXmMOdGDZir1bgu5G2/OTic07LWzKuwAUD/EF6LIB8BBNfnuBl2g8QW5qz3FNCtk+PYYUYTDFm/zyutp/Hns2ohGBvMW7n5FQ==
Received: from HE1EUR02FT025.eop-EUR02.prod.protection.outlook.com
 (10.152.10.54) by HE1EUR02HT115.eop-EUR02.prod.protection.outlook.com
 (10.152.11.173) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_CBC_SHA384) id 15.20.2052.19; Thu, 11 Jul
 2019 16:34:30 +0000
Received: from AM0PR09MB2867.eurprd09.prod.outlook.com (10.152.10.59) by
 HE1EUR02FT025.mail.protection.outlook.com (10.152.10.79) with Microsoft SMTP
 Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_CBC_SHA384) id
 15.20.2052.19 via Frontend Transport; Thu, 11 Jul 2019 16:34:29 +0000
Received: from AM0PR09MB2867.eurprd09.prod.outlook.com
 ([fe80::9dda:c865:5c62:181b]) by AM0PR09MB2867.eurprd09.prod.outlook.com
 ([fe80::9dda:c865:5c62:181b%3]) with mapi id 15.20.2052.020; Thu, 11 Jul 2019
 16:34:29 +0000
From: =?utf-8?B?TGludXMgS8OkbGxiZXJn?= <linus.kallberg@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#36550: Small bug fix in recentf.el
Thread-Topic: bug#36550: Small bug fix in recentf.el
Thread-Index: AQHVNYw5xyUV/E2CqkyMV9zNLq5kYKbBJAyGgABCtoCAANvRnYADX02A
Date: Thu, 11 Jul 2019 16:34:29 +0000
Message-ID: <AM0PR09MB2867803F96B1A7F4A5B4C81687F30@HIDDEN>
References: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
 <87v9wc2t8p.fsf@HIDDEN>
 <AM0PR09MB2867529A5BCE4551365F142C87F60@HIDDEN>
 <m3bly3xsto.fsf@HIDDEN>
In-Reply-To: <m3bly3xsto.fsf@HIDDEN>
Accept-Language: sv-SE, en-US
Content-Language: en-US
X-MS-Has-Attach: yes
X-MS-TNEF-Correlator: 
x-clientproxiedby: HE1PR02CA0111.eurprd02.prod.outlook.com
 (2603:10a6:7:29::40) To AM0PR09MB2867.eurprd09.prod.outlook.com
 (2603:10a6:208:134::10)
x-incomingtopheadermarker: OriginalChecksum:0EA8FB013155E2CA6C5E3B1AD9F36231D5FE86F3CDF29665DA7FECCA0D71D8D0;
 UpperCasedChecksum:F41E28DAA8B0F73AF41A59F25410FE1AAB5CED50A285D6DD60B39DF30CF4BD35;
 SizeAsReceived:7600; Count:49
x-ms-exchange-messagesentrepresentingtype: 1
x-tmn: [wAZZgbq8WY8TWdxvMb3pRtJ6v/IKibCj]
x-microsoft-original-message-id: <314cfa20-8f34-11d6-7978-3b5af1ced0a0@HIDDEN>
x-ms-publictraffictype: Email
x-incomingheadercount: 49
x-eopattributedmessage: 0
x-microsoft-antispam: BCL:0; PCL:0;
 RULEID:(2390118)(5050001)(7020095)(20181119110)(201702061078)(5061506573)(5061507331)(1603103135)(2017031320274)(2017031322404)(2017031323274)(2017031324274)(1601125500)(1603101475)(1701031045);
 SRVR:HE1EUR02HT115; 
x-ms-traffictypediagnostic: HE1EUR02HT115:
x-microsoft-antispam-message-info: taTkN6ad+kjXUll//fxDir1SlblFxY+NWlUPBvKYrNw82kLDQ6pvSrNVLP1tb2BKPFHjfZb3c3LaHnOZ+rJS9Z/ArO32QI5Xq6AWL347WuehhKRueecJ6ZZ70gJLTDcuJJhDI2s3XOd0BUlFAkDG3Ffdt2A6I7xDr7PYgLhpsnZguU6c/pKkvEqp//61EsTy
Content-Type: multipart/mixed;
 boundary="_002_AM0PR09MB2867803F96B1A7F4A5B4C81687F30AM0PR09MB2867eurp_"
MIME-Version: 1.0
X-OriginatorOrg: outlook.com
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-CrossTenant-Network-Message-Id: ec20af4d-8dc5-4636-0099-08d7061da54a
X-MS-Exchange-CrossTenant-rms-persistedconsumerorg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-CrossTenant-originalarrivaltime: 11 Jul 2019 16:34:29.6651 (UTC)
X-MS-Exchange-CrossTenant-fromentityheader: Internet
X-MS-Exchange-CrossTenant-id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-Transport-CrossTenantHeadersStamped: HE1EUR02HT115
X-Spam-Score: 1.3 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Den 2019-07-09 kl. 15:04, skrev Lars Ingebrigtsen: > Linus
    Källberg writes: > >> Okay, makes sense. I just thought it looked a bit
   weird that the first >> character on the next line is highlighted [...] 
 
 Content analysis details:   (1.3 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
                             blocked.  See
                             http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
                              for more information.
                             [URIs: outlook.com]
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
                              no trust
                             [40.92.69.56 listed in list.dnswl.org]
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider (linus.kallberg[at]outlook.com)
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 FROM_EXCESS_BASE64     From: base64 encoded unnecessarily
  1.3 PDS_NO_HELO_DNS        High profile HELO but no A record
X-Debbugs-Envelope-To: 36550
X-Mailman-Approved-At: Thu, 11 Jul 2019 12:36:23 -0400
Cc: "36550 <at> debbugs.gnu.org" <36550 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.3 (/)

--_002_AM0PR09MB2867803F96B1A7F4A5B4C81687F30AM0PR09MB2867eurp_
Content-Type: text/plain; charset="utf-8"
Content-ID: <956D56D3E9FD36448D1710B8C70B2744@HIDDEN>
Content-Transfer-Encoding: base64

RGVuIDIwMTktMDctMDkga2wuIDE1OjA0LCBza3JldiBMYXJzIEluZ2VicmlndHNlbjoNCj4gTGlu
dXMgS8OkbGxiZXJnIDxsaW51cy5rYWxsYmVyZ0BvdXRsb29rLmNvbT4gd3JpdGVzOg0KPiANCj4+
IE9rYXksIG1ha2VzIHNlbnNlLiBJIGp1c3QgdGhvdWdodCBpdCBsb29rZWQgYSBiaXQgd2VpcmQg
dGhhdCB0aGUgZmlyc3QNCj4+IGNoYXJhY3RlciBvbiB0aGUgbmV4dCBsaW5lIGlzIGhpZ2hsaWdo
dGVkIGFzIHdlbGwuIEF0IGZpcnN0IEkgdGhvdWdodA0KPj4gc29tZXRoaW5nIG1vcmUgc2VyaW91
cyB3YXMgYnJva2VuIGluIEVtYWNzLCB0aGF0J3Mgd2h5IEkgbG9va2VkIGludG8gaXQuDQo+IA0K
PiBPaCwgSSBkaWRuJ3QgY2F0Y2ggdGhhdCB0aGUgZmlyc3QgY2hhcmFjdGVyIG9uIHRoZSBuZXh0
IGxpbmUgaXMNCj4gaGlnaGxpZ2h0ZWQuICBUaGF0IGRvZXMgaW5kZWVkIHNlZW0gbGlrZSBhIGJ1
Zy4NCj4gDQo+PiBBIG1pZGRsZSBncm91bmQgd291bGQgYmUgdG8gbW92ZSB0aGUgbmV3bGluZSBi
dXQgcHV0IGEgc2luZ2xlIHNwYWNlDQo+PiBiZWZvcmUgIiVdIiAob3Igc2V0IDpidXR0b24tc3Vm
Zml4ICIgIiksIHRvIGtlZXAgdGhlIGJlaGF2aW9yIGRlc2NyaWJlZA0KPj4gaW4gdGhlIGNvbW1p
dCBtZXNzYWdlLiBCdXQgaXQncyBubyBiaWcgZGVhbCBpbiBhbnkgZXZlbnQgOi0pDQo+IA0KPiBD
b3VsZCB5b3UgcHJvcG9zZSBhIHBhdGNoIHRoYXQgYXZvaWRzIHRoZSBoaWdobGlnaHQgb24gdGhl
IG5leHQgbGluZT8NCg0KT24gc2Vjb25kIHRob3VnaHQsIEkgZG9uJ3QgdGhpbmsgdGhlIHJlYWwg
cHJvYmxlbSBpcyBpbiByZWNlbnRmLmVsLCBidXQgDQpyYXRoZXIgaW4gdGhlIGltcGxlbWVudGF0
aW9uIG9mIHdpZGdldHMgYW5kL29yIGZhY2VzLiBJdCBtYWtlcyBzZW5zZSB0byANCmtlZXAgcmVj
ZW50Zi5lbCBhcyBpdCBpcy4NCg0KSSdtIHByb2JhYmx5IG5vdCBxdWFsaWZpZWQgdG8gZml4IHRo
ZSBidWcsIGF0IGxlYXN0IGluIGEgdGltZWx5IG1hbm5lciwgDQpidXQgSSBkaWQgc29tZSBleHBl
cmltZW50aW5nIGFuZCBjYW1lIHVwIHdpdGggYW4gTVdFLCB3aGljaCBpcyBhdHRhY2hlZCANCnRv
IHRoaXMgZS1tYWlsLiBIb3BlZnVsbHkgaXQgY2FuIGJlIG9mIHNvbWUgaGVscC4NCg0KQmVzdCBy
ZWdhcmRzLA0KTGludXMgS8OkbGxiZXJnDQo=

--_002_AM0PR09MB2867803F96B1A7F4A5B4C81687F30AM0PR09MB2867eurp_
Content-Type: text/plain; name="widgets-mwe.el"
Content-Description: widgets-mwe.el
Content-Disposition: attachment; filename="widgets-mwe.el"; size=1568;
	creation-date="Thu, 11 Jul 2019 16:34:29 GMT";
	modification-date="Thu, 11 Jul 2019 16:34:29 GMT"
Content-ID: <4C1E7A8EA01CD442A407D8D6756466D0@HIDDEN>
Content-Transfer-Encoding: base64
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--_002_AM0PR09MB2867803F96B1A7F4A5B4C81687F30AM0PR09MB2867eurp_--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36550; Package emacs. Full text available.

Message received at 36550 <at> debbugs.gnu.org:


Received: (at 36550) by debbugs.gnu.org; 9 Jul 2019 13:04:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jul 09 09:04:26 2019
Received: from localhost ([127.0.0.1]:60450 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hkpnG-0005qq-GF
	for submit <at> debbugs.gnu.org; Tue, 09 Jul 2019 09:04:26 -0400
Received: from quimby.gnus.org ([80.91.231.51]:45304)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hkpnD-0005qe-Lm
 for 36550 <at> debbugs.gnu.org; Tue, 09 Jul 2019 09:04:24 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hkpn9-0005RI-Fu; Tue, 09 Jul 2019 15:04:21 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Linus =?utf-8?Q?K=C3=A4llberg?= <linus.kallberg@HIDDEN>
Subject: Re: bug#36550: Small bug fix in recentf.el
References: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
 <87v9wc2t8p.fsf@HIDDEN>
 <AM0PR09MB2867529A5BCE4551365F142C87F60@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAElBMVEWqra7Z2tr////+//75
 +fnt7e0mEygKAAACcUlEQVQ4jXVUy5KjMAyUM3CXAr6H1z0kzB2CfLcT9P+/sm2Y1NZma3wyaqvV
 kttQ+8uiX4GGnh+hXg9AHsd3pz8b2x47cP6Jh7Dum2GzVwYuXwcQVDVs2IzfanuGe+znc9zGR2ba
 duCyFw+brrq8NvBWm6bHDuCjN5t09RZ8OzgLihANBuLFZNPJB0236FwYqj2Dnr2E5HVBRnoyM23+
 p3OEkmzJNls8RXbOHUAvZolIABiTiHMQlIHBiyUwSC2JiWcmCKIEtWbbzELuZUZOUqSc8YDowSwy
 TlZmjrw4Ag8oy7ZL4B5x0BZiLgvKxZt6fvZZjAiRi6gRhTE/Gi++VE3IvCIKFodqp0zVVLypUozj
 FcogVZjzrJJcU6kriS89UYl+Ysw9kM1NTZtSURQ4fWoTksp2pxKJRXCl5OMgb8ifjjuXOVGAzHm5
 8il7YXdBrgGxULMsSTgbQA+XyGhVSVApImkG0HW3++3W0lKfzzXGRkWJEWJwzI5d0VJ1OtfCNCPF
 VwyOy5WYypZOVeJ5JAyr/hJ6A8jwC8ckpBNJOku+tkknmDLLlNJR1t8IptrOUkiJDFp8hcHClbFs
 stNmKikXJ1+I1Gw36HG5jfgGasQdazZyd1im9j4DiJfGGpDSShpTssW0bim6qkDLOmWnY+boFX5B
 hoHLM6tOGJ07AJZTS98xWrHM2q14N2dOMGJscvE2OaREZOjHqx2YVhfXvl9vH885OX9Oqut6G9TU
 7uuk/Q70WcX6WBVTea+v3dSB2Yfwt8TlDXTT674/ZLMQtqDBp+c/v4xL7i17keCWj39JQ7zX+A/o
 7vf7pFu+qPaX9Qf/wZ/svmEzWwAAAABJRU5ErkJggg==
Date: Tue, 09 Jul 2019 15:04:19 +0200
In-Reply-To: <AM0PR09MB2867529A5BCE4551365F142C87F60@HIDDEN>
 ("Linus \=\?utf-8\?Q\?K\=C3\=A4llberg\=22's\?\= message of "Mon,
 8 Jul 2019 23:57:42 +0000")
Message-ID: <m3bly3xsto.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 
 Content preview:  (Please keep the debbugs address in the Cc list, otherwise
    the mail won't reach the bug tracker.) Linus Källberg <linus.kallberg@HIDDEN>
    writes: > Okay, makes sense. I just thought it looked a bit weird that the
    first > character on the next line is highlighted as well. At first I thought
    > something more serious was broken in Emacs, that's wh [...] 
 
 Content analysis details:   (-2.9 points, 5.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
                             [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36550
Cc: 36550 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

(Please keep the debbugs address in the Cc list, otherwise the mail
won't reach the bug tracker.)

Linus K=C3=A4llberg <linus.kallberg@HIDDEN> writes:

> Okay, makes sense. I just thought it looked a bit weird that the first=20
> character on the next line is highlighted as well. At first I thought=20
> something more serious was broken in Emacs, that's why I looked into it.

Oh, I didn't catch that the first character on the next line is
highlighted.  That does indeed seem like a bug.

> A middle ground would be to move the newline but put a single space=20
> before "%]" (or set :button-suffix " "), to keep the behavior described=20
> in the commit message. But it's no big deal in any event :-)

Could you propose a patch that avoids the highlight on the next line?

--=20
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36550; Package emacs. Full text available.

Message received at 36550 <at> debbugs.gnu.org:


Received: (at 36550) by debbugs.gnu.org; 8 Jul 2019 19:59:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jul 08 15:59:01 2019
Received: from localhost ([127.0.0.1]:59613 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hkZmr-0004HF-JM
	for submit <at> debbugs.gnu.org; Mon, 08 Jul 2019 15:59:01 -0400
Received: from quimby.gnus.org ([80.91.231.51]:60708)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hkZmm-0004H1-HE
 for 36550 <at> debbugs.gnu.org; Mon, 08 Jul 2019 15:58:56 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.89) (envelope-from <larsi@HIDDEN>)
 id 1hkZmh-0004gj-9y; Mon, 08 Jul 2019 21:58:51 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Linus =?utf-8?Q?K=C3=A4llberg?= <linus.kallberg@HIDDEN>
Subject: Re: bug#36550: Small bug fix in recentf.el
References: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
Date: Mon, 08 Jul 2019 21:58:46 +0200
In-Reply-To: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
 ("Linus \=\?utf-8\?Q\?K\=C3\=A4llberg\=22's\?\= message of "Mon,
 8 Jul 2019 12:54:05 +0000")
Message-ID: <87v9wc2t8p.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 
 Content preview:  Linus Källberg <linus.kallberg@HIDDEN> writes: > Hello,
    > > In recentf.el (GNU Emacs 26.1 (build 1, x86_64-w64-mingw32) of > 2018-05-30),
    I made the following small change on line 1187 (in the > function recentf-open-files-item):
    > > - :format "%[ [...] 
 
 Content analysis details:   (-2.9 points, 5.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
                             [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36550
Cc: 36550 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Linus K=C3=A4llberg <linus.kallberg@HIDDEN> writes:

> Hello,
>
> In recentf.el (GNU Emacs 26.1 (build 1, x86_64-w64-mingw32) of=20
> 2018-05-30), I made the following small change on line 1187 (in the=20
> function recentf-open-files-item):
>
> -           :format "%[%t\n%]"
> +           :format "%[%t%]\n"

(In the future, could you post complete patches instead of fragments?
That makes it easier to find the code in question.)

> This fixes the highlighting when hovering the mouse over a file in the=20
> recent files dialog. Before, the file name, as well as the rest of the=20
> line and the first character on the next line, was highlighted. Now only=
=20
> the file name is highlighted, which looks much nicer and is probably=20
> what is intended.

The commit message for that line seems to indicate that it's on purpose:

commit 5d24c60e3a3b07ccb31b886885ea117a058168be
Author: David Ponce <david@HIDDEN>
Date:   Mon Apr 3 14:34:28 2006 +0000

    (recentf-open-files-item): Include newline in button
    field, so opening a file will work, when the point is at the end
    of the file name.  Allow, for example, to [i]search a file by
    extension and just push RET to open it.

--=20
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36550; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 8 Jul 2019 14:49:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jul 08 10:49:56 2019
Received: from localhost ([127.0.0.1]:59297 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hkUxn-0008Mh-22
	for submit <at> debbugs.gnu.org; Mon, 08 Jul 2019 10:49:56 -0400
Received: from lists.gnu.org ([209.51.188.17]:39680)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <linus.kallberg@HIDDEN>) id 1hkT9m-00056Z-Id
 for submit <at> debbugs.gnu.org; Mon, 08 Jul 2019 08:54:11 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:43580)
 by lists.gnu.org with esmtp (Exim 4.86_2)
 (envelope-from <linus.kallberg@HIDDEN>) id 1hkT9l-0002Up-IQ
 for bug-gnu-emacs@HIDDEN; Mon, 08 Jul 2019 08:54:10 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: ***
X-Spam-Status: No, score=3.3 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 RCVD_IN_DNSWL_NONE,RECEIVED_FROM_WINDOWS_HOST,URIBL_BLOCKED
 autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <linus.kallberg@HIDDEN>) id 1hkT9k-0000KS-DI
 for bug-gnu-emacs@HIDDEN; Mon, 08 Jul 2019 08:54:09 -0400
Received: from mail-oln040092071015.outbound.protection.outlook.com
 ([40.92.71.15]:54814 helo=EUR03-DB5-obe.outbound.protection.outlook.com)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <linus.kallberg@HIDDEN>)
 id 1hkT9j-0000IP-VM
 for bug-gnu-emacs@HIDDEN; Mon, 08 Jul 2019 08:54:08 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=outlook.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=C2w0xgiCl80BIPjP+rrsAuAaeLiF1JrAD8Y1QHp3Zbk=;
 b=ZO1Qo0Zfnf8UicdyzXUkYFc78Wi/iwVNuHCesatxmRn/aP7ucYVPmTtOZzKRAYwnbNYS8qGmUYTYL2JJgMPvUbj3/oda2bVOoLJXON/L+300D54Zgw7g2+Ybe+oSmWtcttiVikn+v+31EChvlT90s5bYDtEkTxeXvT1Ycl5ccWqvQH1KauU1intfe2K9J7IqJrEsUt8Ftf5NUggIvbxJ6+QE01MFLygcNDLdcyyt0xgE67Uqu8jwfEZtphEMgtvU00Td3Si+qhdkg2VCckssGAGrbGxhaT52daYbCkNx/cWfqr8C2mZHV2Br+7bPX4CoXHz+Bx4GsX/YOtFYkSyaNQ==
Received: from VE1EUR03FT017.eop-EUR03.prod.protection.outlook.com
 (10.152.18.54) by VE1EUR03HT225.eop-EUR03.prod.protection.outlook.com
 (10.152.19.45) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.2052.18; Mon, 8 Jul
 2019 12:54:06 +0000
Received: from AM0PR09MB2867.eurprd09.prod.outlook.com (10.152.18.56) by
 VE1EUR03FT017.mail.protection.outlook.com (10.152.18.90) with Microsoft SMTP
 Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.2052.18 via Frontend Transport; Mon, 8 Jul 2019 12:54:06 +0000
Received: from AM0PR09MB2867.eurprd09.prod.outlook.com
 ([fe80::9dda:c865:5c62:181b]) by AM0PR09MB2867.eurprd09.prod.outlook.com
 ([fe80::9dda:c865:5c62:181b%3]) with mapi id 15.20.2052.020; Mon, 8 Jul 2019
 12:54:05 +0000
From: =?Windows-1252?Q?Linus_K=E4llberg?= <linus.kallberg@HIDDEN>
To: "bug-gnu-emacs@HIDDEN" <bug-gnu-emacs@HIDDEN>
Subject: Small bug fix in recentf.el
Thread-Topic: Small bug fix in recentf.el
Thread-Index: AQHVNYw5xyUV/E2CqkyMV9zNLq5kYA==
Date: Mon, 8 Jul 2019 12:54:05 +0000
Message-ID: <AM0PR09MB286736839F8AA277D9B3287987F60@HIDDEN>
Accept-Language: sv-SE, en-US
Content-Language: en-US
X-MS-Has-Attach: 
X-MS-TNEF-Correlator: 
x-clientproxiedby: HE1PR02CA0097.eurprd02.prod.outlook.com
 (2603:10a6:7:29::26) To AM0PR09MB2867.eurprd09.prod.outlook.com
 (2603:10a6:208:134::10)
x-incomingtopheadermarker: OriginalChecksum:861EBE1171AD524BE9297ECCCE192D8F6E8ACA2433AB8A12BC2E3147353358DE;
 UpperCasedChecksum:C6D3F414C8293097B60822AB76D198EA069E37CA5126C8E862D302D94CE781C9;
 SizeAsReceived:7208; Count:46
x-ms-exchange-messagesentrepresentingtype: 1
x-tmn: [2sCuUjZiqOrROqB6m10GzD9es2m4lAmF]
x-microsoft-original-message-id: <a9e8cb5e-613b-78a4-6c01-12cd13b08ef3@HIDDEN>
x-ms-publictraffictype: Email
x-incomingheadercount: 46
x-eopattributedmessage: 0
x-microsoft-antispam: BCL:0; PCL:0;
 RULEID:(2390118)(5050001)(7020095)(20181119110)(201702061078)(5061506573)(5061507331)(1603103135)(2017031320274)(2017031322404)(2017031323274)(2017031324274)(1601125500)(1603101475)(1701031045);
 SRVR:VE1EUR03HT225; 
x-ms-traffictypediagnostic: VE1EUR03HT225:
x-microsoft-antispam-message-info: FJIg8LjF53aYpdZgl7Q6bOUBHeY3USRNbaOjKkxsENHbkaeKeQr+ai5bKONZNo5XRWg1DmVWO3rXVCJHDgzzxaxi0D9QoNoTadeWU6T3ELk61x/EORSH0fuBB9qhWZZsp327Vw/c7KrDoln4g4YMz8TTmHVp7EbGjyWaD7nTDEeNvYTm1ru5IaHXIGQROoKu
Content-Type: text/plain; charset="Windows-1252"
Content-ID: <4CB174A3EBC7D241A899755C6CD81597@HIDDEN>
Content-Transfer-Encoding: quoted-printable
MIME-Version: 1.0
X-OriginatorOrg: outlook.com
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-CrossTenant-Network-Message-Id: 36e6da0c-8547-43ce-c6f7-08d703a35c21
X-MS-Exchange-CrossTenant-rms-persistedconsumerorg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-CrossTenant-originalarrivaltime: 08 Jul 2019 12:54:05.8873 (UTC)
X-MS-Exchange-CrossTenant-fromentityheader: Internet
X-MS-Exchange-CrossTenant-id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-Transport-CrossTenantHeadersStamped: VE1EUR03HT225
X-detected-operating-system: by eggs.gnu.org: Windows 7 or 8 [fuzzy]
X-Received-From: 40.92.71.15
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Mon, 08 Jul 2019 10:49:53 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

Hello,

In recentf.el (GNU Emacs 26.1 (build 1, x86_64-w64-mingw32) of=20
2018-05-30), I made the following small change on line 1187 (in the=20
function recentf-open-files-item):

-           :format "%[%t\n%]"
+           :format "%[%t%]\n"

This fixes the highlighting when hovering the mouse over a file in the=20
recent files dialog. Before, the file name, as well as the rest of the=20
line and the first character on the next line, was highlighted. Now only=20
the file name is highlighted, which looks much nicer and is probably=20
what is intended.

Yours Sincerely,
Linus K=E4llberg




Acknowledgement sent to Linus Källberg <linus.kallberg@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#36550; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 25 Nov 2019 12:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.